'' =================================================================================================
''
''   File....... V3 Cylon project.spin
''   Author..... Stilgar
''   Special thanks to Jon Williams, Brandon Nimon, Chip Gracey, Colin Fox

'' =================================================================================================


con

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000                                          ' use 5MHz crystal
' 

  CLK_FREQ = ((_clkmode - xtal1) >> 6) * _xinfreq
  MS_001   = CLK_FREQ / 1_000
  US_001   = CLK_FREQ / 1_000_000


con

  RX1     = 31
  TX1     = 30
  SDA     = 29
  SCL     = 28

  LED_MSB = 27
  LED_LSB = 12
  Button = 6
  Button_1 = 8 
  LED_Z = 7
  
  ' rtime1 pin 4 
  ' rtime2 pin 5 
   'button pin 6
  ' sound pin 10


con 

  #1, HOME, #8, BKSP, TAB, LF, CLREOL, CLRDN, CR, #16, CLS      ' PST formmatting control
  
_numleds = 16
_firstled = 12
maxbright = 64


obj

  term    : "fullduplexserial"
  rc      : "RCTime3"                                                              ' get object
  led     : "led_pwm_1"

  
var

  long  wavcog
  long  stack[32]
  long  numleds_, firstled_, persistence_, leds[_numleds]    'these must appear in this order
  long  luminosity
  


PUB Scanner | x, t, idx, rtime1, rtime2

    dira [Button]~
 
   term.start(31, 30, %0000, 115200)
  pause(1)

  term.tx(CLS)
  term.str(string("By your command:", CR))
  
  rc.RCTIME_forever(4, 500, 1, @rtime1)          ' start loading sweep speed rtime with current RC value
  waitcnt(clkfreq / 400 + cnt)                 ' allow a little time for rtime to get a value (may need to increase, or be able to decrease)

  rc.RCTIME_forever(5, 500, 1, @rtime2)          ' start loading persistence rtime with current RC value
  waitcnt(clkfreq / 400 + cnt)                  ' allow a little time for rtime to get a value (may need to increase, or be able to decrease)
  
  wavcog := cognew(playsound(10, @Cylon, 0), @stack) + 1      ' start sound player

  term.str(string("Sweep speed = "))
  term.dec(rtime1/1200)
  term.str(string("     ",CR))

   term.str(string("Persistence trail = "))
  term.dec(rtime2/7000)
  term.str(string("     ",CR))
  t := cnt

 
  numleds_ := _numleds
  firstled_ := _firstled

  persistence_ := rtime2/7000


  led.start(@numleds_)

  repeat luminosity from 0 to maxbright

    repeat x from 7 to _numleds-8
      leds[x] := luminosity + 5 
    waitcnt(clkfreq / (rtime1 / 2000)+ cnt)              ' center LEDs slowly go from 0 to maxbright 64
    
                   

  repeat (1)
    repeat x from 7 to _numleds-1
      leds[x] := maxbright
      waitcnt(clkfreq / (rtime1 / 1200)+ cnt)      ' maxbright remains 64 for this code and the rest of full programing

    repeat x from _numleds-1 to 0
      leds[x] := maxbright
      waitcnt(clkfreq / (rtime1 / 1200)+ cnt)
 
  

  repeat
  
       if ina[Button]==0
          Death
          
    repeat x from 0 to _numleds-1
      leds[x] := maxbright
      waitcnt(clkfreq / (rtime1 / 1200)+ cnt)                   ' The delay is after each are set, so they are individual
   
    repeat x from _numleds-1 to 0
      leds[x] := maxbright
      waitcnt(clkfreq / (rtime1 / 1200)+ cnt)
 

           

  led.stop


pub pause(ms) | t

'' Delay program ms milliseconds

  t := cnt - 1088                                               ' sync with system counter
  repeat (ms #> 0)                                              ' delay must be > 0
    waitcnt(t += MS_001)



PUB  Death
    dira[LED_Z]~~
    outa[LED_Z]~~
    repeat
       turnOn_LED
       wait
       turnOff_LED
       wait
       
     if ina[Button_1]==0
          reboot
           

            
Pri turnOn_LED
    outa[7] := 1

Pri turnOff_LED
    outa[7] := 0

PRI wait
    waitcnt(5_000_000 + cnt)
           
pri playsound(pin, pntr, count) | rate, samples, addr, t        ' call with cognew

'' Plays 8-bit, mono audio file from DAT section
'' -- pin is pin for audio (uses CTRA)
'' -- pntr is start of audio
'' -- sampletm is sample timing in cnt ticks
'' -- count is number of plays before cog unloads itself

  if (count =< 0)                                               ' if 0, play "forever"
    count := posx

  rate    := clkfreq / long[pntr + 24]                          ' get rate from header
  samples := long[pntr + 40]                                    ' get samples from header

  frqa := $80 << 24                                             ' set to "0" 
  ctra := (%00110 << 26) + pin                                  ' duty cycle mode on pin
  dira[pin] := 1                                                ' make pin an output
  
  repeat count
    t := cnt
    addr := pntr + 44                                           ' skip over wav header
    repeat samples
      frqa := byte[addr++] << 24                                ' update dac
      waitcnt(t += rate)
      
  ctra := 0
  cogstop(cogid)


pri stopsound

  if wavcog
    cogstop(wavcog~ - 1)


dat

                byte                                            ' force byte alignment
                
Cylon           file    "eye_11.wav"  
CylonEOF        byte    0                                       ' end of file

                      